(function() {

  var baseInit = function() {

    //from index.js
    var bindEvents = function(carousel) {
      var $el = carousel.container;

      $el.on('click', '[class^="arrow-"]', function(e) {
        e.preventDefault();
        var dir = 'prev',
            link = $(this);
        if (link.hasClass('arrow-right')){
          dir = 'next';
        }
        carousel[dir]();
        setTimeout(function(){link.css('margin-right', '0');}, 100);
      });
    };

    if(screen.width >= 600){
      $('.tabs-block').tabs();

      $('.jCarousel').each(function(index, el) {
        $(el).jcarousel({
          auto: ($(el).data('noauto')) ? 0 : 5,
          scroll: 1,
          wrap: 'circular',
          initCallback: bindEvents
        });
      });
    }

    $("a#clear_vision").bind('click', function(){
      document.cookie = "gsr_blind_bg=; expires="+new Date(0)+";path=/";
      document.cookie = "gsr_blind_kern=; expires="+new Date(0)+";path=/";
      document.cookie = "gsr_blind_fs=; expires="+new Date(0)+";path=/";
      $('body').removeClass('black_bg kern_large kern_huge large_fs huge_fs');
      $('a.starblind').filter(':hidden').removeClass('hidden');
      $(this).addClass('hidden');
      $("input:radio[name|='kern[]']").each(function(i){
          if(i==0){
              $(this).attr("checked", "checked");
          }else{
              $(this).removeAttr("checked");
          }
      });
      $("input:radio[name|='bg[]']").each(function(i){
          if(i==0){
              $(this).attr("checked", "checked");
          }else{
              $(this).removeAttr("checked");
          }
      });
      $("input:radio[name|='font_size[]']").each(function(i){
          if(i==0){
              $(this).attr("checked", "checked");
          }else{
              $(this).removeAttr("checked");
          }
      });
    });

    //Heads slider
      $('div.heads').each(function(){
      var $this = $(this);
      var states = {
        small:{
          width:86,
          top:65,
          left:0
        },
        middle:{
          width:122,
          top:38,
          left:-12
        },
        big:{
          width:174,
          top:0,
          left:-39
        },
        speed:400
      };
      function bigToMiddle(el){
        el.animate({
          width:states.middle.width,
          marginTop:states.middle.top,
          marginLeft:states.middle.left
        }, states.speed, function(){
          $(this).css('z-index','2'); 
        });
      }
      function bigToMiddleLeft(el){
        el.css('z-index','2').animate({
          width:states.middle.width,
          marginTop:states.middle.top,
          marginLeft:states.middle.left
        }, states.speed);
      }
      function middleToSmall(el){
        el.animate({
          width:states.small.width,
          marginTop:states.small.top,
          marginLeft:states.small.left
        }, states.speed, function(){
          $(this).css('z-index','1'); 
        });
      }
      function middleToSmallLeft(el){
        el.css('z-index','1').animate({
          width:states.small.width,
          marginTop:states.small.top,
          marginLeft:states.small.left
        }, states.speed);
      }
      function middleToBig(el){
        el.css('z-index','3').animate({
          width:states.big.width,
          marginTop:states.big.top,
          marginLeft:states.big.left
        }, states.speed);
      }
      function smallToMiddle(el){
        el.css('z-index','1').animate({
          width:states.middle.width,
          marginTop:states.middle.top,
          marginLeft:states.middle.left
        }, states.speed, function(){
        $(this).css('z-index','2')
        });
      }
      var slide = $(this).find('div.slide');
      slide.scrollLeft('0');

      $(window).load(function(){
        slide.find('td').addClass('hd');
        slide.find('td:eq(0),td:eq(1),td:eq(2),td:eq(3),td:eq(4)').removeClass('hd');
      });

      slide.find('td:eq(1) img,td:eq(3) img').css({marginTop:'38px', marginLeft:'-12px', zIndex:'2', width:'122px'});
      slide.find('td:eq(2)').addClass('active').find('img').css({marginTop:'0', marginLeft:'-39px', zIndex:'3', width:'174px'});

    var timer = true, animation = false;
      $(this).find('span.next').click(function(){
        if(!animation){
          animation = true;
          var active = slide.find('.active');
          bigToMiddle(active.find('img'));
          middleToSmall(active.prev().find('img'));
          middleToBig(active.next().find('img'));
          smallToMiddle(active.next().next().find('img'));
          active.find('.info').hide().end().next().next().next().removeClass('hd').find("img").css({zIndex: 0});
          slide.scrollTo({top:0,left:'+=98px'}, states.speed, {onAfter:function(){
            active.removeClass('active').next().addClass('active').find('.info').show();
          slide.find('td:first').addClass('hd').appendTo(slide.find('tr'));
          slide.scrollTo({top:0,left:'-=98px'},0);
          timer = true;
          animation = false;
          }});
        }
      });
      $(this).find('span.prev').click(function(){
        if(!animation){
          animation = true;
        slide.find('td:last').addClass('hd').prependTo(slide.find('tr'));
        slide.scrollTo({top:0,left:'+=98px'},0);
          
          var active = slide.find('.active');
          active.find('.info').hide().end().next().next().find('img').css('z-index','0');
          bigToMiddleLeft(active.find('img'));
          middleToSmallLeft(active.next().find('img'));
          middleToBig(active.prev().find('img'));
          smallToMiddle(active.prev().prev().find('img'));
          active.prev().prev().prev().removeClass('hd');
          slide.scrollTo({top:0,left:'-=98px'}, states.speed, {onAfter:function(){
            active.next().next().addClass('hd');
            active.removeClass('active').prev().addClass('active').find('.info').show();
            timer = true;
            animation = false;
          }});
        }
      });
      
      slide.bind('mousewheel', function(event, delta) {
        if(timer){
          timer = false;
        if(delta>0){
          $this.find('span.prev').click();
        } else {
          $this.find('span.next').click();
        }
      }
      return false
    });
    });

    //for social buttons
    $('span.addToSocial').each(function(){
      $(this).prev().mouseenter(function(){
        $(this).next().find('.list').css('display','block');
      });
    }).mouseleave(function(){
      $(this).find('.list').css('display','none');
    });

    //governor gallery

    var _html = $('html');

    if(($('ul.photoalbum').length > 0) && !_html.hasClass('ie6') && !_html.hasClass('ie7')){
      (function(window, $, PhotoSwipe){
        var options = {};
        $("a", ".photoalbum").photoSwipe(options);
      }(window, window.jQuery, window.Code.PhotoSwipe));
    }
    //end governor gallery

    //Answer-question toggle
      $('.q', '.p-questions').on("click", function(){
          $(this).next('.a').slideToggle();
          return false;
      });

  };
//end init

  var bigTablesCheck = function(){
    //for big content tables

    if($('body').is(':has(.article .textblock table)')){
      var link = '<span class="view-all-table">Развернуть на всю ширину</span>',
          table = $('.textblock table'),
          cr = $('.cr'),
          crm = $('.cols .cl .crm'),
          crmMr = crm.css('margin-right'),
          maxWidth = crm.width();

      $('.gallery table').addClass('ignored');

      table.each(function(){
        var t = $(this);

        if( ! t.is('.ignored') ){
          if( (t.width() > maxWidth) ){
            if($(document).width() > 800)
            {
                $(link).insertBefore(t);
                t.wrap('<div class="table-container" />');
            }
          }
        }
      });

        $('.view-all-table').toggle(
          function() {
            cr.hide();
            $(this).text('Свернуть');
            crm.css('margin-right','0');
            $(this).text('Свернуть');
            $('.table-container').removeClass('table-container').addClass('fixTable');
          },
          function() {
             $('.fixTable').removeClass('fixTable').addClass('table-container');
             $(this).text('Развернуть на всю ширину');
             cr.show();
             crm.css('margin-right', crmMr);
          });
      }
  };

  var formUpdate = function(){
  //update for #reception_form

    if($('body').is(':has(#reception_form)')){
      var itm = $('.itm');
      itm.has('#id_number_house').addClass('short first');
      itm.has('#id_building_house').addClass('short');
      itm.has('#id_apartment').addClass('short');
    }

    //change checkbox html
    var itmClasses = $('.current_date_job, #id_agreement, #id_send_mail');

    itmClasses.each(function(){
      var itmInput = $(this);
      var itm = itmInput.parents('.itm');
      itm
        .html('<div class="fr nm"><label>' + itm.find('label').text() +'</label></div>')
        .find('label').prepend(itmInput);
    });
  };

  var browsersTabs = function(){
    $('.browsers_choice ul').delegate('li:not(.current)', 'click', function() {
      var $this = $(this);
      $this.addClass('current').siblings().removeClass('current');
      $this.children('input').prop('checked', true);
      $this.parents('div.browsers').find('div.box').hide().eq($this.index()).fadeIn('slow');
    })
  };
/*
  //start calendar
  var newsCalendar = function(){
    var dates = {};

    var loadDates = function(key, el){
        var container = $(el).closest(".ui-daterangepicker"),
            pickers = $('.range-start, .range-end', container);

        $.ajax({
            url: "",
            dataType: 'json',
            data: {
                key: key
            },
            success: function(data){
                dates[key] =  data.dates;
                pickers.datepicker("refresh");
            }
        });
    };

    var highlightDays = function(date){
        var key;
        if(this && date){
            key = $.datepicker.formatDate('mm.yy', date);
            if (dates[key] === "loading") {
                return [true, ''];
            } else if (!dates[key]) {
                dates[key] = "loading";
                loadDates(key, this);
                return [true, ''];
            }else{
                var inArr = $.inArray($.datepicker.formatDate('dd.mm.yy', date), dates[key]) >= 0;
                return inArr ? [true, 'ui-state-has']: [true, ''];
            }
        }
        return [true, ''];
    }

    $('#calendar').daterangepicker({
        datepickerOptions: {
            beforeShowDay: highlightDays
        },
        rangeSplitter: "по",
        dateFormat:'dd.mm.yy',
        presetRanges: [
            {text: 'Сегодня', dateStart: 'today', dateEnd: 'today' },
            {text: 'За неделю', dateStart: 'today-7days', dateEnd: 'today' },
            {text: 'За текущий месяц', dateStart: function(){ return Date.parse('today').moveToFirstDayOfMonth();  }, dateEnd: 'today' }
        ],
        presets:  {
            specificDate: 'За день',
            dateRange: 'Период'
        },
        rangeStartTitle: 'Начало периода',
        rangeEndTitle: 'Конец периода',
        doneButtonText: 'Выбрать'
    }
    );
    $(".btnDone").click(function(){
        $("form.calendar").submit();
    });
    $("form.calendar").submit(function(){
        var params = $("#calendar", this).val().split(' по ');
        window.location = "?" + $.param({start: params[0], end: params[1] || ''});
        return false;
    });
}
//end calendar
 */
$(function(){
    baseInit();
    bigTablesCheck();
    formUpdate();
    css_browser_selector(navigator.userAgent);
    /*if ($('#calendar').length > 0){
        newsCalendar();
    }*/
    browsersTabs();
    
  });
})();

//for adaptive layout
$(document).ready(function(){
  $(window).resize(function(){
    if($(this).width() < 600){
      $('#carousel-banners, #carousel-bottom').css('display','none');
    }
    else{
      $('#carousel-banners, #carousel-bottom').css('display','block');
    }
  });
});